﻿using System;

public partial class _Default : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        // If it is not a PostBack then go and fetch the initial values from Excel
        if (!IsPostBack)
        {
            // Open the workbook using the current culture (don't want any defaults)
            string baseDir = System.AppDomain.CurrentDomain.BaseDirectory;
            string filePath = baseDir + "App_Data\\ConcatRangeWithSeparator.xlsm";
            SpreadsheetGear.IWorkbook WorkbookInterface = SpreadsheetGear.Factory.GetWorkbook(filePath, System.Globalization.CultureInfo.CurrentCulture);

            // Fetch initial values from the Inputs worksheets to the text boxes
            SpreadsheetGear.IWorksheet InputWorksheet = WorkbookInterface.Worksheets["Inputs"];
            cell1.Text = InputWorksheet.Cells["Cell1"].Range.Text;
            cell2.Text = InputWorksheet.Cells["Cell2"].Range.Text;
            cell3.Text = InputWorksheet.Cells["Cell3"].Range.Text;
            cell4.Text = InputWorksheet.Cells["Cell4"].Range.Text;
            cell5.Text = InputWorksheet.Cells["Cell5"].Range.Text;
            cell6.Text = InputWorksheet.Cells["Cell6"].Range.Text;
            cell7.Text = InputWorksheet.Cells["Cell7"].Range.Text;
            cell8.Text = InputWorksheet.Cells["Cell8"].Range.Text;
            separator.Text = InputWorksheet.Cells["Separator"].Range.Text;
        }
    }

    protected void concatCalc_Click(object sender, EventArgs e)
    {
        // Open the workbook using the current culture (don't want any defaults)
        string baseDir = System.AppDomain.CurrentDomain.BaseDirectory;
        string filePath = baseDir + "App_Data\\ConcatRangeWithSeparator.xlsm";
        SpreadsheetGear.IWorkbook WorkbookInterface = SpreadsheetGear.Factory.GetWorkbook(filePath, System.Globalization.CultureInfo.CurrentCulture);

        // Add the VBA function to the workbook
        WorkbookInterface.WorkbookSet.Add(ConcatRangeWithSeparator.ConcatRangeWithSeparatorSingleton);

        // Reference the Inputs and Outputs worksheets
        SpreadsheetGear.IWorksheet InputWorksheet = WorkbookInterface.Worksheets["Inputs"];
        SpreadsheetGear.IWorksheet OutputWorksheet = WorkbookInterface.Worksheets["Outputs"];

        // Post text box values to the workbook
        InputWorksheet.Cells["Cell1"].Range.Value = cell1.Text;
        InputWorksheet.Cells["Cell2"].Range.Value = cell2.Text;
        InputWorksheet.Cells["Cell3"].Range.Value = cell3.Text;
        InputWorksheet.Cells["Cell4"].Range.Value = cell4.Text;
        InputWorksheet.Cells["Cell5"].Range.Value = cell5.Text;
        InputWorksheet.Cells["Cell6"].Range.Value = cell6.Text;
        InputWorksheet.Cells["Cell7"].Range.Value = cell7.Text;
        InputWorksheet.Cells["Cell8"].Range.Value = cell8.Text;
        InputWorksheet.Cells["Separator"].Range.Value = separator.Text;

        // Get expense values
        result1.Text = OutputWorksheet.Cells["B2"].Range.Value.ToString();
        result2.Text = OutputWorksheet.Cells["C2"].Range.Value.ToString();
    }

}